2021-08-14  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.1.4

	* arcOp.c : the DrawArc procedure now checks that the arc is not
	  drawn with a zero linewidth - otherwise some pixels could have
	  been missing, and any later fill area procedure could then have
	  led to unexpected results. This minor bug (or misbehavior?)
	  has been fixed.

        * image.c : if installed, dvipng can now be used as an alternative
	  to the libdvipgm library, at the expense of a small slowdown
	  in the output. This allows TeX input even without libdvipgm
	  installed, dvipng being installable independently.

2021-02-12  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.1.3

	* graphic.c : the "Text" menu has been substantially improved.
	  Text and TeX/LaTeX input of arbitrary length, size, color can
	  now be edited and converted to either a bitmap image or
	  vector PostScript/PDF with embedded fonts.

        * More extensive testing - and a lot of small details fixed

2021-01-28  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.1.2

        * Small improvement of versions 3.1.0, 3.1.1 with bug fixes.
	  Xpaint can now be compiled without dvipgm (at the expense of
	  losing some TeX functionality). Thanks to testers for feedback!

        * This version supports the use of layers (files *.lxp =
	  Layered XPaint files). This is done via the C script editor.
	  Any collection of images can be combined into a new merged 
	  image by a suitable C procedure. See example in directory
	  share/c_scripts/templates/

        * Compiling against libkpathsea and libdvipgm (from the
	  dvipgm-1.x.tar.bz2 package, x >= 2) is needed to enable TeX
	  input processing - otherwise the compilation scripts will
	  disable TeX input. A minimal TeX environment is also needed
	  to allow TeX interaction.

        * xpaintrw/readLXP.c : routines for reading LXP files

        * iprocess.c : routines for the creation of LXP files

        * image.c : ImageDup() procedure added

        * operation.c : new option for cleaning temporary files

        * This version has reached all capabilities that had been planned
	  since a long time: layer handling, vector graphics operations,
	  possibility of TeX input and of mathematical drawings,
	  programmatic creation of images, filters and graphical functions.
	  Therefore Xpaint will probably enter into maintainance and
	  bug correction mode. 

2021-01-27  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.1.1

        * Small improvement of version 3.1.0 with bug fixes.

        * This version supports the use of layers (files *.lxp =
	  Layered XPaint files). This is done via the C script editor.
	  Any collection of images can be combined into a new merged 
	  image by a suitable C procedure. See example in directory
	  share/c_scripts/templates/

        * Compiling against libkpathsea and libdvipgm (from the
	  dvipgm-1.x.tar.bz2 package, x >= 2) is needed to enable TeX
	  input processing - otherwise the compilation scripts will
	  disable TeX input. A minimal TeX environment is also needed
	  to allow TeX interaction.

        * xpaintrw/readLXP.c : routines for reading LXP files

        * iprocess.c : routines for the creation of LXP files

        * image.c : ImageDup() procedure added

        * operation.c : new option for cleaning temporary files

        * This version has reached all capabilities that had been planned
	  since a long time: layer handling, vector graphics operations,
	  possibility of TeX input and of mathematical drawings,
	  programmatic creation of images, filters and graphical functions.
	  Therefore Xpaint will probably enter into maintainance and
	  bug correction mode. 

2021-01-24  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.1.0

        * This version now supports the use of layers (files *.lxp =
	  Layered XPaint files). This is done via the C script editor.
	  Any collection of images can be combined into a new merged 
	  image by a suitable C procedure. See example in directory
	  share/c_scripts/templates/

        * Compiling against libkpathsea and libdvipgm (from the
	  dvipgm-1.x.tar.bz2 package, x >= 2) is needed to enable TeX
	  input processing - otherwise the compilation scripts will
	  disable TeX input. A minimal TeX environment is also needed
	  to allow TeX interaction.

        * xpaintrw/readLXP.c : routines for reading LXP files

        * iprocess.c : routines for the creation of LXP files

        * image.c : ImageDup() procedure added

        * operation.c : new option for cleaning temporary files

        * This version has reached all capabilities that had been planned
	  since a long time: layer handling, vector graphics operations,
	  possibility of TeX input and of mathematical drawings,
	  programmatic creation of images, filters and graphical functions.
	  Therefore Xpaint will probably enter into maintainance and
	  bug correction mode ...

2021-01-21  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.0.5

        * Vector drawing capabilities improved and hopefully almost complete.

        * Xpaint now allows the use of TeX input in mathematical drawings,
	  provided it is compiled with the compilation flag -DHAVE_DVIPGM.
	  The libdvipgm and libkpathsea libraries are required for this.
	  
	* The new 'vxp2tex' utility converts VXP data into a TeX file
	  that can be used with pdftex or pdflatex.

        * lineOp.c : ticks and graduation procedure added.

        * graphic.c, image.c, iprocess.c : several fixes and improvements.

2021-01-09  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.0.4

        * This version has acquired substantial vector drawing capabilities.
	  Just open 'Options->VXP vector data Editor' to enable vector
	  drawing operations. Most of them are recorded in a plain text
	  "VXP format" *.vxp. The external program 'vxp2ps' converts these
	  data into (vector) postscript, and 'vxp2dkw' can be used to
	  convert them for use in in the handwritten note editor deskwrite.
          Such Postscript files can be easily converted to PDF or SVG.

        * Xpaint can also read and rasterize *.vxp files (but at this point
          all operations that are not translated right away into vector data
          are ignored, even though they are recorded in the VXP file).

        * graphic.c, operation.c, misc.c, iprocess.c : extensive additions
	  to implement VXP data processing.

	* share/c_scripts/procedures : canvas+vxp.c added as a new example.
          C scripts can be used to produce VXP data.
	

2020-08-04  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.0.3

        * This version of xpaint requires in principle libXaw3dXft-1.6.2h
	  (but would run with 1.6.2d,e by removing the compilation flag
	  -DHAVE_NEWEDITINGSTYLE)

        * graphic.c: a new option has been introduced, allowing xpaint
          to use more easily graphics tablets, more specifically the
	  user space drivers provided with deskwrite on Sourceforge.

        * menu.c: SetFocusOn() has been fixed. This allows the input focus
	  to be preserved in active text fields, even when the cursor
	  leaves the top parent window (as is usually expected with modern
	  desktop interface guidelines ...)

        * iprocess.c: small improvement of the Gamma/RGB filter.

	* Further small fixes throughout, especially in the build scripts
	  and the debian packaging.

2020-06-29  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.0.2

        * This version of xpaint requires libXaw3dXft-1.6.2h
	  (or later versions of the libXaw3dxft library - the changes
	  between 'f', 'g' and 'h' merely consist of introducing a new
	  parameter to allow scrollbars of text widgets to be on the right
	  side, plus some minor improvements in the edition process)
	  Removing -DHAVE_NEWEDITINGSTYLE in Makefile.am
	  would make xpaint compatible with earlier versions 1.6.2d,e
	  of libxaw3dxft with essentially no change, except for the text
	  input editing behavior of Backspace and Delete keys.

        * xpaintrw/readWritePNM.c: is now using a more recent version
	  of libnetpbm, rather than the completely obsolete version from
	  the 1990's that was embedded in the original code of xpaint.
	  One consequence is that libnetpbm10-dev or preferably
	  libnetpbm11-dev are now needed to compile xpaint, another
	  one is that PPM/PAM files with an alpha channel can now be read
	  and written. Adjust the NETPBM defines (-DNETPBM10 or -DNETPBM11)
	  according to the installed version of libnetpbm.

        * help.c: the help widget now has two independently resizable
	  panes (topics and explanations).

        * pattern.c: correction of old bug (that had however no visible
	  effect before 3.0.1).

	* graphic.c: exchange of primary and secondary colors or patterns
	  is now accessible by clicking on the red cross below the
	  color picker (shown as an eye). Similar addition for pattern.c

2020-06-16  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.0.1

        * This version of xpaint requires libXaw3dXft-1.6.2f
	  (or later versions of the libXaw3dxft library).
	  Removing -DHAVE_NEWEDITINGSTYLE in Makefile.am
	  would make it compatible with earlier versions 1.6.2d,e
	  with essentially no change except for the text input
	  editing behavior of Backspace and Delete keys.

	* print.c: by default, xpaint no longer depends on cups-bsd commands,
	  (but they can be re-enabled via an adjutsment of the
	  app-defaults files).

        * xpaintrw/readWritePS.c: the BoundingBox of a file saved as PS/PDF
	  should now be set appropriately.

	* graphic.c, *Op.c: extensive additions.
	  Xpaint can now record all operations that are performed as vector
	  data, in the so called VXP format. The recording starts as soon as
	  the VXP editor under the Options menu is started, and these data
	  can be saved into a file <name>.vxp

	* readWriteJP2K.c: has been ported to work with openjpeg version 2
	  (JPEG2000 format), including alpha channel.

        * Various other small fixes throughout (SVG import, ...)

	* At a later stage, it will be possible to convert these VXP files
	  to other vector formats such as eps, pdf or svg, and import
	  them back to xpaint. There will be also an option to insert
	  TeX input and convert the data into a (La)TeX file.

2020-05-25  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 3.0.0

        * bitmaps/toolicons: new set of icons, generated from SVG data.

	* app_defaults: the app_defaults files have been reorganized
	  so as to separate linguistic strings and other data, especially
	  widget sizes. Three sizes are now offered: big, medium, small,
	  to accommodate HiDPI screens or low resolution screens.

        * operation.c: the tool window is now fully resizable.
	  In order to actually change the size of icons, users can copy
	     /usr/share/xpaint/bitmaps/toolicons/
	  into
	     $HOME/.xpaint/toolicons/
	  and generate icons with larger or smaller size there. Just type
	  ./generate_icons <height> in $HOME/.xpaint/toolicons/ to
	  produce a new set of icons with the given height (the xpaint
	  package is distributed with icons of default height 36).
	  The shell script "generate_icons" requires inkscape to work.

        * graphic.c: the parameter btnheight is now used to resize
	  the palette elements as well as the height of buttons.
	  This is useful for HiDPI screens (as well as for lower
	  resolution screens of older computers).

        * main.c: new option -blind that keeps xpaint running under the
          hood when batch procedures are invoked.

	* xpaintrw/readWritePS.c: SVG import has been updated to work
	  with inkscape-1.0.

	* The change of major number in this version anticipates the
	  introduction of some vector graphics capabilities in the
	  versions 3.x.y to come. (Right now, the only vector graphics
	  capabilities are PS, PDF, SVG import).

2020-05-21  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 2.10.3

        * lineOp.c : under the "segment" operation, users will now find
	  new "Position" and "Measurement" tools. These tools do not draw
	  anything, but instead they record the locations of pixels that
	  are clicked on, and compute lengths and angles.

        * iprocess.c : The "Perspective" filter has been vastly improved.
	  It should now enable users to correct the perspective of a
	  distorted picture taken by a camera, or to create artificial
	  perspective when producing a drawing. This can be used in
	  connection with the new "Position" tool, so as to specify points
	  on the canvas.

	* iprocess.c : The API of C scripts introduces a new public procedure
	  PixelInterpolate(unsigned char *op, Image *input, double x, double y)
	  that can be used to smooth pixels, under transformations that
	  map integer coordinates into float values (as is the case
	  e.g. for rotations or homotheties with arbitrary factor).
	  This will sometimes improve the output of such operations
	  (but may also make the image fuzzier).

	* Two new C scripts "similarity.c" and "projective.c" have been added.
	  They show in particular how to exploit the PixelInterpolate()
	  procedure.

        * Help and message files have been edited to explain details of
	  the new functionalities.

2017-11-13  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 2.10.2

        * Minor compilation fixes in iprocess.c and xpaintrw/readWriteJP2K.c
	  thanks to the OpenSUSE team.

        * Bug in operation.c : exitPaint(...) could trigger a segfault when
	  quitting xpaint without saving the canvas. Thanks to Anthony
	  J. Bentley from the OpenBSD team for reporting the bug.

        * misc.h : srandom() is nowadays always of void type.

        * Minor fixes for the calculation of the maximum canvas size.

2016-12-10  J.-P. Demailly  <jean-pierre.demailly@univ-grenoble-alpes.fr>

        * Version 2.10.1 (a substantial update!).

        * Xpaint includes a new command line option
	  -btnheight that adjusts appropriately the size of all internal
	  widgets in case a big menu font is used (e.g. by setting the
	  option -menufont , or by changing the app-defaults file).
	  This is very useful if you have a high resolution screen.
	  Many small local modifications of various source files in
	  the main tree have been necessary for this.

        * A new option -toolmode 0,1,2 can be used to initialize the
	  display of the tool window. Also adjustable dynamically by
	  resizing that window.

        * Default canvas size has been set to 1024x768
	  Related command line options are -canvassize and -winsize
	  that can be used independently to adjust the default size of
	  canvas and main window.

        * The app-defaults files and help files have been modified
	  to accommodate the above additions.

        * The "Print" widget has been improved, and its menubar is now
	  again available to adjust page formats (a bug introduced
	  probably a long time ago prevented it to work !)

        * A newer version libXaw3dXft-1.6.2e.tar.bz2 has been posted.
	  The only change is a 3 lines addition that circumvents (what
	  seems to be) a bug occurring in certain X11/Xorg implementations,
	  e.g. the intel driver, version 2.99.917. Otherwise this will
	  make no difference.

        * Changed the library name librw to libxpaintrw
	  to avoid shared library conflicts. Thanks to Michael Orlitzky
	  for pointing out the issue.

        * Applied a number of patches from gentoo.org that substantially
	  improve the compilation process. Thanks to Julian Ospald
	  <hasufell@gentoo.org>

2015-01-02  J.-P. Demailly  <jean-pierre.demailly@ujf-grenoble.fr>

        * Version 2.9.10.3

	* Port to the newer libXaw3dXft-1.6.2d.tar.bz2 (the latter is
	  actually a requirement, this version no longer compiles
	  with libXaw3dXft-1.6.2c). The point is that libXaw3dXft-1.6.2d
	  has improved binary compatibility with plain libXaw3d-1.6.x

	* Only further cosmetic changes, no change in functionality.

2014-04-17  J.-P. Demailly  <jean-pierre.demailly@ujf-grenoble.fr>

        * Version 2.9.10.2

        * Minor fixes in 'configure.ac' and 'configure.old' scripts
          Xpaint can now be compiled again with plain Xaw or Xaw3d
          (this is NOT recommended, Xaw3dxft definitely gives much
          better results !) Thanks to Stefan Husmann (Arch Linux)
          for helpful reports in this respect.

        * 'configure' (based on autotools) and 'configure.old' (based on
          imake) should in most cases give essentially equivalent binaries.

        * PDF files are now read by using mudraw if mupdf & mupdf-tools
          are installed (otherwise Xpaint falls back to the formerly used
          solution: pdf2ps + ghostscript, a much slower one...)

        * Xpaint can now even import libreoffice files as images as soon
          as libreoffice is installed (assuming /usr/bin/libreoffice is
          a valid path to the main program)

2014-04-09  J.-P. Demailly  <jean-pierre.demailly@ujf-grenoble.fr>

        * Version 2.9.10.1

        * Includes the "version_and_focus_patch_for_2.9.10" and other
          minor fixes.

        * The alpha channel menu now includes a new function that allows 
          editing as RGB values the image that appears when transparency
          is applied on a background of the selected background color -
          white being the default (this removes the transparency levels
          afterwards, so as to get a pure RGB image).

        * Bug (probably very old) corrected : selection of background color
          always resulted in black being chosen !

2014-03-03  J.-P. Demailly  <jean-pierre.demailly@ujf-grenoble.fr>

        * Version 2.9.10

        * This version should preferably be compiled with libXaw3dXft-1.6.2c,
          although it still works Ok with libXaw3dXft-1.6.2b.

	* readWritePNG.c: fixed bug occurring when writing grayscale images
          possessing no more than 16 colors.

        * readWriteJPEG.c: JPEG images in CMYK colorspace are now handled 
          properly (they will still be memorized as RGB, so the original
          CMYK information is lost, but at least they are shown correctly).

        * fileBrowser.c: "Save" and "Save as" menus now include the option
          to adjust JPEG quality between 50% and 100% (default is 90%)

        * fileBrowser.c: improved logic : the file browser now remembers
          file names when changing directories, and also takes into
          account default extension when specifying file format.

        * fileBrowser.c: thanks to a new feature from libXaw3dXft-1.6.2c
          (possibility of creating colored lists), xpaint now
          implements file type coloring in its file browser - at this
          point this is guessed merely from the suffix of the file.

        * operation.c: Canvas menu reorganized - it is now named
          "File menu" so as to conform to general use. Except from
          reordering the items, the main functionality is unchanged.

	* pattern.c: bug fixes. A segfault problem in the zoom selector
          has been corrected, and contextual help has been fixed.

2013-01-27  J.-P. Demailly  <jean-pierre.demailly@ujf-grenoble.fr>

        * Version 2.9.9.4

        * This version should be compiled with libXaw3dXft-1.6.2b

        * RGB channel separation procedure fixed and improved

        * Fix in CRC data handling of regions in memory.

        * XPaint now remembers better the position of regions saved in memory.
          The recorded position can now be changed or reset to origin through
          the memory management menu.

	* compilation fix for pgf2pnm with newer libpgf-6.12.24

        * Avoid "bool" variable throughout, as this is a typedef in <stdbool.h>

        * Fixes to configure scripts, thanks to Daniel Macks (fink project)

        * Minor GUI improvements

2012-02-14  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.9

	* Xpaint now uses (or tries to use!) autotools.

	* libxaw3dxft is now a separate package (but is still a requirement,
	  and in fact should be installed before).

	* xpaintrw/rwTable.c : segfault fix (occurring randomly) fixed in
	  readMagic().

	* minor fix in fontSelect.c, certain fonts were possibly missing
	  in the font browser, in some rare circumstances.

	* very minor fix of scrollbar behaviour in graphic.c.

	* misc.c : new procedure SetWMInputHint() that helps solving some
	  quirks.

2012-01-06  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.8.4

	* minor fixes in fileBrowser.c (adjustable height of text entry
          for the file name, resize procedure improved).

2011-10-13  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.8.3

	* xpaintrw/pgf-util/Makefile : add '-fpermissive' flag to allow
	  compilation with recent (more picky!) versions of g++

        * Xaw3dxft/Viewport.c : position of scrollbars can now be adjusted
          through parameters sbShift[X,Y][1,2]. No public API change, so
          this addition should be upward compatible.

        * graphic.c : some small fixes in the shellHandler routine to
          accommodate odd behavior of scrollbars with xorg recent versions,
          using the new sbShift feature.

2010-12-29  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.8.2 - nothing really new, just very small fixes

        * Integrated patch to facilitate compilation with gcc-4.5

        * app-defaults files : slight improvement of X event management
          in pull-down menus.

        * print.c : slight improvement of X event management in print widget.

        * fontOp.c : fixed color issue (color not initialized) when moving
          written text with arrow keys.

        * Very small changes in Xaw3dxft (minor Xaw3dXft.h API update)

2010-11-08  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.8

	* Xaw3dxft : code clean-up. New files Xaw3dXft.h and Xaw3dXft.c
	  now contain the specific Xaw3dxft parameters and routines.
	  A couple of small improvements to correct minor quirks in the
	  menu entry highlighting behaviour.

	* main.c, graphic.c : changes made to accommodate the API changes
	  introduced in Xaw3dxft. Further code clean-up.

	* image.h, graphic.c, iprocess.c : modified definition of
	  the imageprocessinfo struct, so that hopefully compilation
	  still works with gcc 4.5 (gcc-4.5 appears to be more picky with
	  struct definitions). Thanks to Fedora maintainer Paulo Roma
	  Cavalcanti <promac@gmail.com> for reporting the issue.

2010-11-01  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.7

        * Arrow keys and "Backspace", "Return", "Escape" keys can now
          be used in all drawing operations whose effect is not immediate,
          especially all routines from
            arcOp.c, lineOp.c, polygonOp.c, freehandOp.c, splineOp.c, TextOp.c
          Arrow keys allow moving objects around before they are
          completely drawn,  "Escape" restarts the operation from scratch,
          "Return" terminates the operation, and "Backspace" rewinds the
          course of operation backwards.

        * freehandOp.c : this operation now allows to draw arbitrary
          combinations of freehand and polygonal shapes and should
          be easier to use or to modify interactively thanks to the key
          bindings.

        * sprayOp.c : minor code clean-up.

        * updated accordingly Help files.

2010-10-25  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.6.4
          A couple of small improvements in spline, polygon, text and
          color operations.

        * fontOp.c, splineOp.c, polygonOp.c : implemented "Backspace"
          key action,  i.e. removing last point or last character;
          "Escape" now entirely restarts the operation from the beginning.
          Other small improvements (including correction of a potential
          segfault occurring in some strange circumstances...);
          polygonOp() code is now also much simpler and easier to read.

        * graphic.c : multiple clicks on any of the three color/pattern
          selection discs now switch primary and secondary colors/patterns.

        * updated accordingly Help files.

2010-10-08  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.6.3 - minor bug fix release - nothing really serious.

        * ops.h : minor compilation issue fixed.

        * graphic.c : corrected segfault bug of RegionToRGBA channels
          (occurring only when alpha channel was to be saved.)

        * chroma.c : fixed minor scrolling issue in color variance scrollbars.

        * graphic.c : added new menu lines to proceed more easily to editing
          of alpha channels or images in memory.

        * updated accordingly Help files, messages and app-defaults files.

2010-09-26  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.6.2

        * print.c : printing was completely broken, as a result of using
          double values instead of float values. Reverted to float !

        * chroma.c, color.c, magnifier.c, fontSelect.c : revert to float !

        * iprocess.c : fixed bug occurring only in very rare circumstances
          (creation of image with an alpha channel, being edited and
           compiled on the fly through the embedded C-script editor)

        * graphic.c : small improvement in ModifyRGB (new routine to
          rescale gray levels linearly from given thresholds).

2010-09-14  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.6

        * xpaintrw/rwTable.c, xpaintrw/readWriteTGA.c : fixes in TGA format,
	  so as to prevent that xpaint could hang on certain non TGA files.
          Make sure anyway that TGA is parsed as a last resort, since TGA
          is a strange format without signature.

        * image.c, iprocess.c, graphic.c : substantial improvements in
          filter routines :
          - Added new "Merge" filter : helpful to combine smoothly an image
            with the underlying canvas. Works according to 4 different modes
          - Added new "Distortion" filter which can be used to produce
            local deformations
          - Added powerful Floyd-Steinberg algorithm (color quantification
            enhanced with a diffusion process).
          - Replaced "ModifyRGB" by a generalized RGB transformation procedure
            with 7 different modes, including Gamma correction (with
	    independent r_gamma, g_gamma, b_gamma parameters), and
	    linear transform.
          - Fixed several shortcomings of "Normalize contrast" and "Emboss"
            routines; "Emboss" now has 2 parameters allowing linear correction.
          - Renamed "Tilt" as "Projective Transform" with several enhancements.
          - Renamed "ImageCopy" as "ImageCopyData" which says more accurately
            what it does.

        * graphic.c : Memory menu : management of R,G,B and alpha channels :
          - Added extraction of red, green, blue, alpha channels from region
          - Added merge procedure for those channels

        * msgedit.c : new utility which can be used to extract strings from
          the English version of "Messages" and combine them with a partially
          localized "Messages_XY" for any other language - useful as well to
          avoid discrepancies between languages!

        * Many updates to Message and Help files.

2010-09-05  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.5

        * xpaintrw/readWritePNG.c : fixed WritePNG() for alpha channel images
          possessing less than 16 black and white colors, which xpaint
          tried to write in an incorrect PNG mode.

        * graphic.c : fixed segfault bug when invoking "Clone Canvas"
          procedure.

        * xaw3dxft : a few hacks to work around minor display bugs related
          to Xft anti-aliasing/composition effects on certain X servers
          (especially proprietary NVIDIA ...)

        * main.c : new command line options -tooltips, -notooltips

        * operation.c, graphic.c : implemented tooltips (they can be disabled
          from the tools/help menu).

        * man page and help files : updated.

2010-08-15  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.4

        * xpaintrw/readWriteTGA.c : added support for TGA format (borrowed
          mostly from mtpaint project).

        * xpaintrw/rwTable.c : code clean-up.

        * Paint.c, PaintRegion.c : fixes for certain complex situations
          involving region selection with masks and alpha channel.
          (Segfault could occur in Fatbits editor under those circumstances).

        * graphic.c : Suppression of alpha channel could lead to segfault.

2010-08-05  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.3

        * xpaintrw/readWriteICO.c : imported a lot of code from the 'icoutil'
          GPLed package. As a result, xpaint can now read most Windows
          ICO files, even those containing embedded compressed PNG/JPG
          images which icoutil cannot fully open. Support for ICO masks
          as alpha channel, and for writing single image ICO files.

        * xpaintrw/readWritePGF.c : PGF image format support improved, thanks
	  to 'pgf2pnm' provided by Christoph Stamm <christoph.stamm@fhnw.ch>
	  (creator of the PGF format). libpgf and libpgf-dev are needed
	  only optionally to compile 'pgf2pnm', which then provides PGF
	  support in xpaint. However, xpaint itself does not link with
	  libpgf and does not need libpgf-dev to be compiled.
	  The alpha channel of PGF images is fully supported.

        * graphic.c : improvements/bug fixes in the "Clone with Zoom"
          procedure. Now works for zooming/downscaling images,
          with/without interpolation, and for adjusting alpha channel
          as well.

        * graphic.c, PaintEvent.c : much more powerful implementation of
          the "Delimit region" procedure, according to six different
          options (connected/non connected/color range regions, or
	  complements of such regions).

        * The help files have been updated to reflect all current
          functionality of XPaint (Spanish help additions should be
          revised by a native speaker !)

2010-07-29  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.2

        * xpaintrw/*.c : huge code clean-up. Saving files now show up a warning
          when the image possesses an alpha channel, but the format chosen
          does not support it (completely or in part). Note: saving in PNG
          should almost always be a safe choice ...

	* xpaintrw/readWriteTIFF.c : support substantially improved, including
          alpha channel read/write. More exotic TIFF formats unsupported.

        * xpaintrw/readWriteBMP.c : many more BMP image format types are now
          supported, including full support for images with an alpha channel
          (read/write).

        * xpaintrw/readWritePNM.c : provisions made to include support for
          alpha channel in PNM (this is a specific extension of xpaint :
          an RGB image concatenated with a gray level image of the same
          size - and '\n' in between - is viewed as RGBA data).

        * xpaintrw/readWriteJP2K.c : added support for JPEG2000 image format.
          Either libopenjpeg (default) or libjasper (optionally) can
          be used. Full support for alpha channel (requires openJPEG
          from subversion at this point now, since "stable" version 1.3
          has insufficient alpha channel implementation...).

        * xpaintrw/readWritePGF.c : added support for PGF image format.
          This requires libpgf and pgf to be installed (but xpaint
          does not need to be linked against libpgf, and its compilation
          does not require libpgf-dev files either.)

        * xpaintrw/readWriteSGI.c : repaired old dormant code to read
          run-length encoded SGI/Irix image files. Checked to work fine.

        * xpaintrw/readWriteICO.c : unsupported, very buggy code. Disabled
          at this point. Instead, use e.g. 'icoutil' to convert those
          files to PNG ...

        * dialog.c : very small fix providing UTF8 support in AlertBox
          window titles (and always raising warning windows).

        * configure : if libXaw3dxft is installed as a shared library,
          compilation is now set by default to use it, rather than
          linking statically xpaint to libXaw3dxf.a

2010-07-18  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.1.5

	* graphic.c : added "*allowResize: False" in Canvas*pane*form
	  to prevent annoying widget initialization on certain platforms

	* xpaintrw/readWritePS.c : small fixes to handle correctly PS/PDF
	  files whose names contain quotes or blank characters.

2010-07-05  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.1.4

        * fatBitsEdit.c, Paint.c , Paintregion.c : several fixes in
          handling of alpha channel in fatbits editor - some affecting
          alpha channel image bits.

        * app-defaults : change zoom labels to correct values xx:1 instead
          of 1:xx

        * graphic.c : prevent fatbits editor getting called undeservedly by
          GetNonDirtyCanvas() routine ; removing alpha channel now moves it
          to memory rather than destroying it right away.

        * xpaintrw/readWritePS.c : fix for compilation of TeX/LaTeX files
          being called from random directories.

        * minor fixes throughout - thanks to the SUSE-Packman maintainer
          Detlef Reichelt <detlef@die-mafia.de> for help.

2010-06-02  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.1

        * Paint.c , Paintregion.c : fixes in alpha channel routines.

        * fatBitsEdit.c : many fixes in fatbits editor. Refresh button added

        * graphic.c : reload file procedure didn't reload alpha channel - this
          is now fixed.

        * fontOp.c : potential segfault corrected.

        * small other (mostly random) improvements.

2010-05-16  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.9.0

        * graphic.c, Paint.c :  big improvements in handling of
          alpha channel ; alpha management menu is now explicit
          from canvas menu bar. Support still not quite complete at
          this point (regions do not appear yet in alpha mode).
          Should come for 2.9.1...

        * Paint.c, PaintRegion.c : fixed segfault occurring when using
          region operations in fatbits editor (regression introduced already
          in 2.8.9 which remained unnoticed up to 2.8.19 ...)

        * fontOp.c, fontSelect.c : UTF8 support should now be essentially
          complete.

        * xpaintrw/readWritePNG.c : fixed bug when writing
	  PNG_COLOR_TYPE_PALETTE images with less than 16 colors (those
	  images were wrongly converted to gray palette...)

        * several other small fixes and improvements throughout.

2010-04-17  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.19.1 (mostly cosmetic changes)

        * fileBrowser.c : added "ongoing" mode in File Browser (widget no
          longer closes when opening an image, allowing to browse files
          continuously). Performed a substantial code clean-up as well.

        * operation.c, graphic.c : menu improvements; one can now open an image
          from any canvas window.

        * misc.c : added RaiseWindow() routine to comply better with ewmh
          specifications. XMapRaised() replaced by RaiseWindow() throughout.

        * "snapshot" replaced by "screenshot" throughout.

2010-04-05  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.19

        * fileBrowser.c : fixed minor annoyance in "save" and "saveas"
          routines - name of file is now again remembered when a filename
          has already been set.

        * graphic.c : fixed bug in ToolSelection switcher; "font" menu
          replaced by more powerful "text" menu; new entry added
          to edit/write text from text editor embedded in font browser.

        * iprocess.c : fixed bug in filter "adjust RGB colors"

        * fontSelect.c, fontOp.c : text sample is now editable, and this text
          can be imported on canvases. This includes being able to set fonts,
          colors, linespacing (etc) as editable text. Any UTF8 encoded file
          can be read and edited, and a small number of special commands
          are available to format such texts; for hints on how to use this,
          see "Doc/TextFormat.doc". Xpaint can thus  be used as a text editor
          (sort of!), useful e.g. to create posters with text and graphics.

        * xpaintrw/readWritePS.c : support for reading a file as
	  "enriched text".

        * main.c : new command line options -textfont and -astext, the latter
          for opening files as enriched text.

        * share/bin/imgmerge : small tweak to use a static PageInfo struct,
          otherwise imgmerge would segfault (gcc bug ?)

2010-03-13  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.18

        * Minor fixes (UTF8 names in windows, rare segfault when using
          external viewer)

        * xpaintrw/readWritePNG.c : xpaint now saves correctly gray images
          which have an alpha channel.

        * xpaintrw/rwTable.c : introduces auto-detect mode for writing
          files (image type is guessed from suffix of file name,
          and set to PNG as a fallback).

        * xaw3dxft : changed library name to libXaw3dxft to avoid
          interfering with regular libXaw3d. Added hooks in 'configure'
          to (possibly) install and compile it as a shared library.
          Corrected an issue in xaw3dxft/List.c which could sometimes
          lead to a fatal X error.

        * Added man pages for imgmerge and pngconcat (provided by Debian
          maintainer Josué Abarca)

        * Removed dependency on Xft.h in PaintP.h which had the unfortunate
          effect of breaking C-Script compilation, e.g. in imgmerge.

2010-03-06  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.17

        * Xpaint is now fully UTF8 compliant. This has been done rather
          cheaply by linking statically with a modified xaw3d library
          which is UTF8 & Freetype aware. This also means that anti-aliasing
          is enabled in the menus and text widgets, and that the X core font
          protocol is no longer used anywhere.

        * By default, Xpaint no longer depends on external xaw/xaw3d/xaw3dg
          libraries as it is compiled with its own improved xaw3d clone;
          this only adds approximately 250 kB to the binary executable.

        * Xpaint can still be used with 8 bit encoding by specifying the
          command option 'xpaint -encoding 8'. However the resource files
          XPaint* Messages* Help* should then preferably be converted back
          to a 8bit locale, otherwise some strange characters will show up
          in the menus, at least in languages which use non ASCII characters.

2010-02-17  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.16.1

	* fontSelect.c, misc.c : introduced clickFocusCallback which
	  fixes keyboard focus in fontSelect and in color picker
	  ascii text input widgets (problem occurred e.g. under KDE).
	  Use 2.8.16 with xpaint-2.8.16-keyboard-input.patch.

2010-02-12  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.16

        * graphic.c, fontOp.c, fontSelect.c : Xpaint now uses the Xft protocol
          to display fonts, so that (in particular) all TrueType fonts are
          available, and the corresponding glyphs are nicely anti-aliased
          without resorting to a use of sub-pixel resolution.
          Another benefit is the possibility of rotating text, or even
          applying arbitrary linear transformation (however, writing fonts
          with a pattern instead of a plain color is no longer possible
          directly - for this, one can use instead masks or a fill
          procedure).

        * xpaintrw/readWritePNG.c : applied small patch from Stefan Husmann
          (Arch Linux maintainer) to take care of API deprecation
          in newer versions libpng-1.4.x.

2010-02-01  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.15

        * PaintRegion.c : finally found and corrected long standing bug
          which plagued iteration of filters and undo procedures.

        * fileBrowser.c : several GUI improvements.

        * xpaintrw/readWritePS.c : improved handling of BoundingBoxes.
          Fixed bug in the use of 'psselect' which was found on the Fedora
          bugzilla list (many thanks to Paulo Roma Cavalcanti
          <promac@superig.com.br> for analyzing the issue)

2010-01-29  J.-P. Demailly  <demailly@fourier.ujf-grenoble.fr>

        * Version 2.8.14

        * graphic.c : memory management simplified and improved; added CRC32
          checksum control to avoid duplicates.

        * xpaintrw/readScript.c : fixed potential bug occurring in rare
	  circumstances.

        * Various fixes in batch scripts 'imgmerge', 'batch.c' and 'xpaint_ocr'
          GPLv3 licence specified there.
[--snip--]
